<script setup lang="ts">
import { computed, onMounted, ref } from 'vue';
import { useGameStore } from '../stores/gameStore';
import type { Person } from '../types/Person';
import SdgUserImage from '../components/SdgUserImage.vue';
import SdgButton from '../components/SdgButton.vue';
import SectionExpando from '../components/SectionExpando.vue';
import { useFirebaseStore } from '@/stores/firebaseStore';
import dayjs from 'dayjs';
import type { CashInRequest } from '@/types/CashInRequest';

type AdminItems = { person: Person; checked: boolean };

const gameStore = useGameStore();
const firebaseStore = useFirebaseStore();

const adminUsers = ref<AdminItems[]>([]);
const adminSaved = ref<boolean>(false);
const blacklistUsers = ref<AdminItems[]>([]);
const blacklistSaved = ref<boolean>(false);
const blacklistWithSdgEmail = ref<boolean>(true);
const blacklistWithNonSdgEmail = ref<boolean>(true);
const blacklistUnchecked = ref<boolean>(true);
const blacklistWithNoImage = ref<boolean>(true);

const pointsPerBuck = ref<number>(firebaseStore.config.pointsNeededForOneSdgBuck);
const maxBucks = ref<number>(firebaseStore.config.maxBucksPerPerson);
const configSaved = ref<boolean>(false);
const cashInTransactionList = ref<CashInRequest[]>([]);

const filteredBlacklist = computed(() => {
  return blacklistUsers.value.filter((x) => {
    let included = (blacklistWithSdgEmail.value && x.person.mail?.includes('solutiondesign.com')) || (blacklistWithNonSdgEmail.value && !x.person.mail?.includes('solutiondesign.com'));
    included = included && (!blacklistUnchecked.value || x.checked === false) && (!blacklistWithNoImage.value || !x.person.image);
    return included;
  });
});

function formatDate(theDate: Date) {
  const date = dayjs(theDate);
  // Then specify how you want your dates to be formatted
  return date.format('dddd MMMM D, YYYY');
}

async function loadAdmin() {
  adminUsers.value = gameStore.directory.map((person) => ({ person, checked: false })).sort((a: AdminItems, b: AdminItems) => (a.person.displayName < b.person.displayName ? -1 : 1));

  const currentAdmins = firebaseStore.admins;
  adminUsers.value.forEach((user) => (user.checked = currentAdmins.some((b: any) => b.id === user.person.id)));

  cashInTransactionList.value = (await firebaseStore.cashInTransactionList()).sort((a, b) => b.date - a.date);
}
async function onAdminSave() {
  const admins = adminUsers.value.filter((user) => user.checked).map((user) => ({ name: user.person.displayName, id: user.person.id }));
  await firebaseStore.saveAdmins(admins);
  adminSaved.value = true;
}

function onAdminChanged() {
  adminSaved.value = false;
}

async function loadBlacklist() {
  blacklistUsers.value = gameStore.directory.map((person) => ({ person, checked: false })).sort((a: AdminItems, b: AdminItems) => (a.person.displayName < b.person.displayName ? -1 : 1));

  const currentBlacklisted = firebaseStore.blacklist;
  blacklistUsers.value.forEach((user) => (user.checked = currentBlacklisted.some((b: any) => b.id === user.person.id)));
}
async function onBlacklistSave() {
  const blacklisted = blacklistUsers.value.filter((user) => user.checked).map((user) => ({ name: user.person.displayName, id: user.person.id }));
  await firebaseStore.saveBlacklist(blacklisted);
  blacklistSaved.value = true;
}

function onBlacklistChanged() {
  blacklistSaved.value = false;
}

async function onConfigSave() {
  await firebaseStore.saveConfig({ pointsNeededForOneSdgBuck: pointsPerBuck.value, maxBucksPerPerson: maxBucks.value });
}

async function loadData() {
  await loadAdmin();
  await loadBlacklist();
}
onMounted(async function () {
  await loadData();
});

async function onCashInClick() {
  const processRows = cashInTransactionList.value.filter((x) => x.process);
  await gameStore.processCashInRequests(processRows);
  await loadData();
}
</script>

<template>
  <div class="grid place-items-center">
    <SectionExpando title="Cash In Transactions" class="w-1/2 p-4 m-10 bg-blue-200">
      <table class="p-4 text-xl bg-white border-separate shadow-ld">
        <thead>
          <tr>
            <th class="border">Name</th>
            <th class="border">SdgBucks</th>
            <th class="border">Cash In Date</th>
            <th class="border">Processed</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="row in cashInTransactionList" :key="row.date">
            <td class="p-2 border">{{ row.name }}</td>
            <td class="p-2 border">{{ row.sdgBucks }}</td>
            <td class="p-2 border">{{ formatDate(new Date(row.date)) }}</td>
            <td class="p-2 border">
              <div v-if="!row.credited">
                <input type="checkbox" v-model="row.process" />
              </div>
              <div v-else>
                {{ formatDate(new Date(row.creditDate || 0)) }}
              </div>
            </td>
          </tr>
        </tbody>
      </table>
      <div class="p-4 text-center">
        <SdgButton color="bg-green-600" @onClick="onCashInClick"> Save </SdgButton>
      </div>
    </SectionExpando>

    <SectionExpando title="Config" class="w-1/2 p-4 m-10 bg-blue-100">
      <div class="p-4 bg-white border-separate shadow-lg">
        <div><label>Points needed for one Sdg Buck:</label> <input class="border-2" v-model="pointsPerBuck" /></div>
        <div><label>Max bucks per person:</label> <input class="border-2" v-model="maxBucks" /></div>
        <SdgButton class="mt-2 text-center" color="bg-sdg-blue" @onClick="onConfigSave">
          <span class="text-black">Save</span>
        </SdgButton>
        <div v-if="configSaved" class="text-center">Saved</div>
      </div>
    </SectionExpando>

    <SectionExpando title="Admin Users" class="w-1/2 p-4 m-10 bg-blue-200">
      <table class="p-4 bg-white border-separate shadow-lg">
        <thead>
          <tr>
            <th class="border">Admins</th>
            <th class="border">Image</th>
            <th class="border">Info</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="user in adminUsers" :key="user.person.id">
            <td class="text-center border">
              <input type="checkbox" name="admin" :value="user.person.id" v-model="user.checked" @click="onAdminChanged" />
            </td>
            <td class="border" style="width: 100px"><SdgUserImage :person="user.person" /></td>
            <td class="border">
              <div>Name: {{ user.person.displayName }}</div>
              <div>Mail: {{ user.person.mail }}</div>
              <div>Dept: {{ user.person.department }}</div>
              <div>Type: {{ user.person.userType }}</div>
            </td>
          </tr>
        </tbody>
      </table>
      <SdgButton class="text-center" color="bg-sdg-blue" @onClick="onAdminSave">
        <span class="text-black">Save</span>
      </SdgButton>
      <div v-if="adminSaved" class="text-center">Saved</div>
    </SectionExpando>

    <SectionExpando title="Blacklist" class="w-1/2 p-4 m-10 bg-blue-400">
      <table class="p-4 bg-white border-separate shadow-lg">
        <thead>
          <tr>
            <td>
              <input type="checkbox" v-model="blacklistWithSdgEmail" /> people with sdg emails<br />
              <input type="checkbox" v-model="blacklistWithNonSdgEmail" /> people with non-sdg emails<br />
              <input type="checkbox" v-model="blacklistUnchecked" /> unchecked people<br />
              <input type="checkbox" v-model="blacklistWithNoImage" /> no images
            </td>
          </tr>
        </thead>
        <tbody>
          <tr>
            <th class="border">Blacklist</th>
            <th class="border">Image</th>
            <th class="border">Info</th>
          </tr>
          <tr v-for="user in filteredBlacklist" :key="user.person.id">
            <td class="text-center border">
              <input type="checkbox" name="admin" :value="user.person.id" v-model="user.checked" @click="onBlacklistChanged" />
            </td>
            <td class="border" style="width: 100px"><SdgUserImage :person="user.person" /></td>
            <td class="border">
              <div>Name: {{ user.person.displayName }}</div>
              <div>Mail: {{ user.person.mail }}</div>
              <div>Dept: {{ user.person.department }}</div>
              <div>Type: {{ user.person.userType }}</div>
            </td>
          </tr>
        </tbody>
      </table>
      <SdgButton class="text-center" color="bg-sdg-blue" @onClick="onBlacklistSave">
        <span class="text-black">Save</span>
      </SdgButton>
      <div v-if="blacklistSaved" class="text-center">Saved</div>
    </SectionExpando>
  </div>
</template>
